﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour
{
    public static Ball instance;
    public Paddle paddle;
    public Vector3 paddleToBallVector;
    private bool GameStarted = false;
    private Rigidbody2D BallVelocity;

    // Use this for initialization
    void Start()
    {
        GameObject.FindObjectOfType<LoseCollider>();
        paddle = GameObject.FindObjectOfType<Paddle>();
        paddleToBallVector = this.transform.position - paddle.transform.position;
        GameStarted = false;

    }


    // Update is called once per frame
    void Update()
    {
        if ((Input.GetMouseButtonDown(0)) && (!GameStarted))
        {
            GameStarted = true;
            this.GetComponent<Rigidbody2D>().velocity = new Vector2(Random.Range(-2f, 2f), 12f);
        }
    }

    void OnCollisionEnter2D(Collision2D collision)
    {
        Vector2 tweak = new Vector2(Random.Range(-0.5f, 0.5f), Random.Range(0f, 2f));
        GetComponent<Rigidbody2D>().velocity += tweak;
        if (GameStarted == true)
        {
            GetComponent<AudioSource>().Play();
        }
    }
    public void Reset()
    {
            GameStarted = false;
            ImmediateStop();
            this.transform.position = new Vector2(paddle.transform.position.x, 1f);
            paddleToBallVector= paddleToBallVector - paddle.transform.position;
    }
    void ImmediateStop()
    {
        this.GetComponent<Rigidbody2D>().velocity = new Vector2(0, 0);
    }

}
