﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Brick : MonoBehaviour
{
    public AudioClip crack;
    public Sprite[] hitSprites;
    public static int breakableCount;
    public GameObject smoke;

    private LevelManager levelManager;
    private int timesHit;

    bool isBreakable;

    // Use this for initialization
    void Start()
    {
        isBreakable = (this.tag == "Breakable");
        //keep track of count
        if (isBreakable)
        {
            breakableCount++;
            print(breakableCount);
        }
        timesHit = 0;
        levelManager = LevelManager.FindObjectOfType<LevelManager>();
    }

    // Update is called once per frame
    void Update()
    {
    }
    void OnCollisionExit2D(Collision2D collision)
    {

        puffSmoke();
        AudioSource.PlayClipAtPoint(crack, transform.position, 2f);
        if (isBreakable) {
            HandleHits();
        }
    }


    void HandleHits()
    {
        timesHit++;
        int maxHits = hitSprites.Length + 1;
        if (timesHit >= maxHits)
        {

            breakableCount--;
            print(breakableCount);
            levelManager.BrickDestroyed();
            
            Destroy(gameObject);
        }
        else
        {
            LoadSprites();
        }
    }
    void LoadSprites()
    {
        int spriteIndex = timesHit - 1;
        if (hitSprites[spriteIndex] != null)
        {
            this.GetComponent<SpriteRenderer>().sprite = hitSprites[spriteIndex];
        }
        else
            Debug.LogWarning("No Brick Sprite");
    }
    void puffSmoke()
    {
        GameObject smokepuff = Instantiate(smoke, transform.position, Quaternion.identity) as GameObject;
        // smokepuff.GetComponent<ParticleSystem>().startColor =  gameObject.GetComponent<SpriteRenderer>().color;
    }
}